public class ClassReader {
    private boolean inPublicSection = false;
    private CppClass parsedClass;
    private List declarations = new ArrayList();
    private Reader reader;
 
    public ClassReader(Reader reader) {
        this.reader = reader;
    }
    public void parse() throws Exception {
        TokenReader source = new TokenReader(reader);
        Token classToken = source.readToken();
        Token className = source.readToken();
 
        Token lbrace = source.readToken();
        matchBody(source);
        Token rbrace = source.readToken();
 
        Token semicolon = source.readToken();
 
        if (classToken.getType() == Token.CLASS
                && className.getType() == Token.IDENT
                && lbrace.getType() == Token.LBRACE
                && rbrace.getType() == Token.RBRACE
                && semicolon.getType() == Token.SEMIC) {
        parsedClass = new CppClass(className.getText(),
                    declarations);
        }
    }
    ...
}
